package jcg.zheng.demo;

import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.LoggerContext;

public class ChangeLogLevelDemo {

	private final Logger lOG = LoggerFactory.getLogger(this.getClass());
	private final static List<String> VALID_LEVELS = Arrays.asList("TRACE", "DEBUG", "INFO", "WARN", "ERROR");

	private static Scanner scanner;

	public static void main(String[] args) {
		ChangeLogLevelDemo demo = new ChangeLogLevelDemo();
		scanner = new Scanner(System.in);
		demo.step("some log message");
		String updateLogLevel = null;
		do {
			System.out.println("Enter Logback Logger Level - TRACE, DEBUG, INFO, WARN, ERROR! ");
			System.out.println("q to quit, anything else to repeat this message: ");

			updateLogLevel = scanner.nextLine();
			if (VALID_LEVELS.contains(updateLogLevel)) {
				setLogLevel(updateLogLevel, "jcg.zheng.demo");

				demo.step("log message after level change");
			}

		} while (!updateLogLevel.equalsIgnoreCase("q"));

		scanner.close();

	}

	public void step(String logmessage) {

		if (lOG.isTraceEnabled()) {
			lOG.trace("Start step for {}", logmessage);
		}

		if (lOG.isDebugEnabled()) {
			lOG.debug("Start step for {}", logmessage);
		}

		if (lOG.isInfoEnabled()) {
			lOG.info("Start step {}", logmessage);
		}

		if (lOG.isWarnEnabled()) {
			lOG.warn("Start step {}", logmessage);
		}

		if (lOG.isErrorEnabled()) {
			lOG.error("Start step {}", logmessage);
		}
	}

	private static void setLogLevel(String logLevel, String packageName) {
		LoggerContext loggerContext = (LoggerContext) LoggerFactory.getILoggerFactory();

		ch.qos.logback.classic.Logger logger = loggerContext.getLogger(packageName);
		System.out.println(packageName + " current logger level: " + logger.getLevel());
		System.out.println(" You entered: " + logLevel);

		logger.setLevel(Level.toLevel(logLevel));
	}
}
